// имитация пульта RC-1 
// ИК управления камерами Canon
// с расширенной функциональностью на Arduino

int ledPin = 13;       // счетчик таймера - встроенный светодиод на 13 выводе
int ir_ledPin = 12;    // ИК передатчик-светодиод подключен к порту 12
int potentiometer = 2; // аналоговый порт подключения потенциометра

// аналоговые порты 0-5 переопределены, как цифровые 14-19

int type_rc_switch = 14; // порт подключения переключателя запуска съемки без паузы и с паузой
int start_switch = 15; // порт подключения кнопки включения съемки
int switch1 = 17;      // порт подключения переключателя "1" управления временем задержки в цикле 
int switch2 = 18;      // порт подключения переключателя "2" управления временем задержки в цикле 
int switch3 = 19;      // порт подключения переключателя "3" управления временем задержки в цикле 

// установки генератора ИК сигнала

int hfreq = 10;        // полупериод несущей, микросекунды
int puls = 20;         // число периодов несущей в пакете импульсов

int pdelay_1 = 7300;   // пауза между пакетами импульсов
int pdelay_2 = 5500;   // пауза между пакетами импульсов

int pdelay = 0;        // переменная, определяющая режим работы с паузами pdelay_1 или pdelay_2

long cycle_delay = 0;  // переменная, пауза в цикле съемки, миллисекунды

void setup()           // инициализация портов
{
  pinMode(ledPin, OUTPUT);    // инициализация порта индикаторного светодиода
  pinMode(ir_ledPin, OUTPUT); // инициализация порта управления ИК диодом  
  pinMode(potentiometer, INPUT); // порт подключения потенциометра - вход
  pinMode(start_switch, INPUT);  // порт переключателя включения съемки - вход
  digitalWrite(start_switch, HIGH); // включение подтягивающего резистора для порта включения камеры
  pinMode(switch1, INPUT);  // порт переключателя "1" управления задержкой съемки - вход
  digitalWrite(switch1, HIGH);  // включение подтягивающего резистора для порта включения камеры 
  pinMode(switch2, INPUT);  // порт переключателя "2" управления задержкой съемки - вход
  digitalWrite(switch2, HIGH);  // включение подтягивающего резистора для порта включения камеры
  pinMode(switch3, INPUT);  // порт переключателя "3" управления задержкой съемки - вход
  digitalWrite(switch3, HIGH);  // включение подтягивающего резистора для порта включения камеры
  pinMode(type_rc_switch, INPUT);  // порт переключателя управления задержкой съемки - вход
  digitalWrite(type_rc_switch, HIGH);  // включение подтягивающего резистора для порта включения камеры
}

void loop()           // управляющий блок в основном цикле           
{
while (digitalRead(start_switch)==HIGH) // включение съемки, если включен переключатель "старт"
 {
  if (digitalRead(type_rc_switch)==HIGH) // выбор режима пульта - обычный или с задержкой перед каждым срабатыванием
   {
    pdelay=pdelay_2; // выбран режим с паузой перед спуском затвора  
   }
  else
   {
    pdelay=pdelay_1; // выбран режим без паузы перед спуском затвора  
   }

// Задание паузы в миллисекундах с помощью переключателей и потенциометра, 
// пауза по умолчанию - 1 с

cycle_delay = 1 + 0.1*analogRead(potentiometer); //1024 шага потенциометра "округляются" до 100   
cycle_delay = cycle_delay + digitalRead(switch1);
cycle_delay = cycle_delay + 2*digitalRead(switch2);
cycle_delay = cycle_delay + 4*digitalRead(switch3);

// Блок индикатор задержки, мигает равное задержке в секундах число раз; после отладки закомментировать

    for (int i=0; i<cycle_delay; i++)
      {
  digitalWrite(ledPin, HIGH);  // индикаторный светодиод включен
  delay(500);                  // ждем 0,5 секунды
  digitalWrite(ledPin, LOW);   // индикаторный светодиод выключен
  delay(500);                  // ждем 0,5 секунды
       }
// Конец блока индикатор задержки


// Блок ИК сигналов управления камерой:

   for (int k=0; k<2; k++)       // цикл два импульса-пакета и пауза
   {
    for (int i=0; i<puls; i++) // цикл серии импульсов в пакете с частотой несущей 
     {
      digitalWrite(ir_ledPin, HIGH);  // включение ИК светодиода
      delayMicroseconds(hfreq);       // длительность импульса включения, микросекунды
      digitalWrite(ir_ledPin, LOW);   // выключение ИК светодиода
      delayMicroseconds(hfreq);       // длительность импульса выключения
     }
    delayMicroseconds(pdelay);        // пауза между пакетами импульсов 
   }
   
// Индикатор на 13 порте показывает срабатывание ИК светодиода 
    digitalWrite(ledPin, HIGH);   // индикаторный светодиод включен
    delay(500);                   // горит 0,5 секунды
    digitalWrite(ledPin, LOW);    // индикаторный светодиод выключен
//

     delay(1000*cycle_delay); // задержка срабатывания затвора
 }   
}
